#include "SI24R1.h"
#include "CH554.H"
#include "DEBUG.H"
#include"SPI.H"

unsigned char code TX_ADDRESS[TX_ADR_WIDTH] = {0x0A,0x01,0x07,0x0E,0x01};  // һ̬͵ַ

/*Ӳӿڶ*****************************************************************
ʹCH552 ӲSPIӿ
		 CH552        DIR
		 P1.4        <==>       SCS
		 P1.5        <==>       MOSI
		 P1.6        <==>       MISO
		 P1.7        <==>       SCK
*******************************************************************************/
static unsigned char SPI_RW(unsigned char byte)
{
	unsigned char bit_ctr;

	for (bit_ctr = 0; bit_ctr < 8; bit_ctr++)
	{
		if (byte & 0x80)
			MOSI = 1;
		else
			MOSI = 0;
		byte = (byte << 1);
		SCK = 1;
		byte |= MISO;
		SCK = 0;
	}

	return byte;
}


/********************************************************
ܣSI24R1ųʼ                
ڲ
  ֵ
*********************************************************/
void SI24R1_Init(void)
{
	P1_MOD_OC &= 0x0F;
	P1_DIR_PU |= 0xB0;//SCS,MOSI,SCK
	P1_DIR_PU &= 0xBF;//MISO踡
	SCK = 0;//SPIʱ
	SCS = 1;				
	CE 	= 0;				
	IRQ = 1;
}


/********************************************************
ܣдĴֵֽڣ                
ڲreg:ĴӳַʽWRITE_REGreg
					value:Ĵֵ
  ֵ״̬Ĵֵ
*********************************************************/
unsigned char SI24R1_Write_Reg(unsigned char reg, unsigned char value)
{
	unsigned char status;

	SCS = 0;                 
	status = SPI_RW(reg);				
	SPI_RW(value);
	SCS = 1;  
	
	return(status);
}


/********************************************************
ܣдĴֵֽڣ                  
ڲreg:ĴӳַʽWRITE_REGreg
					pBuf:д׵ַ
					bytes:дֽ
  ֵ״̬Ĵֵ
*********************************************************/
unsigned char SI24R1_Write_Buf(unsigned char reg, const unsigned char *pBuf, unsigned char bytes)
{
	unsigned char status,byte_ctr;

  SCS = 0;                                  			
  status = SPI_RW(reg);                          
  for(byte_ctr=0; byte_ctr<bytes; byte_ctr++)     
    SPI_RW(*pBuf++);
  SCS = 1;                                      	

  return(status);       
}							  					   


/********************************************************
ܣȡĴֵֽڣ                  
ڲreg:ĴӳַʽREAD_REGreg
  ֵĴֵ
*********************************************************/
unsigned char SI24R1_Read_Reg(unsigned char reg)
{
 	unsigned char value;

	SCS = 0;    
	SPI_RW(reg);			
	value = SPI_RW(0);
	SCS = 1;              

	return(value);
}


/********************************************************
ܣȡĴֵֽڣ                  
ڲreg:ĴӳַREAD_REGreg
					pBuf:ջ׵ַ
					bytes:ȡֽ
  ֵ״̬Ĵֵ
*********************************************************/
unsigned char SI24R1_Read_Buf(unsigned char reg, unsigned char *pBuf, unsigned char bytes)
{
	unsigned char status,byte_ctr;

  SCS = 0;                                        
  status = SPI_RW(reg);                           
  for(byte_ctr=0;byte_ctr<bytes;byte_ctr++)
    pBuf[byte_ctr] = SPI_RW(0);                   //ȡݣֽǰ
  SCS = 1;                                        

  return(status);    
}


/********************************************************
ܣSI24R1ģʽʼ                      
ڲ
  ֵ
*********************************************************/
void SI24R1_RX_Mode(void)
{
	CE = 0;
	SI24R1_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);	// 豸ͨ0ʹúͷ豸ͬķ͵ַ
	SI24R1_Write_Reg(WRITE_REG + EN_AA, 0x01);               						// ʹܽͨ0ԶӦ
	SI24R1_Write_Reg(WRITE_REG + EN_RXADDR, 0x01);           						// ʹܽͨ0
	SI24R1_Write_Reg(WRITE_REG + RF_CH, 40);                 						// ѡƵͨ0x40
	SI24R1_Write_Reg(WRITE_REG + RX_PW_P0, TX_PLOAD_WIDTH);  						// ͨ0ѡͷͨͬЧݿ
	SI24R1_Write_Reg(WRITE_REG + RF_SETUP, 0x0f);            						// ݴ2Mbps书7dBm
	SI24R1_Write_Reg(WRITE_REG + CONFIG, 0x0f);              						// CRCʹܣ16λCRCУ飬ϵ磬ģʽ
	SI24R1_Write_Reg(WRITE_REG + STATUS, 0xff);  									//ежϱ־λ
	CE = 1;                                             								// CE豸
}						
/*
CE = 0;
	SI24R1_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);	// 豸ͨ0ʹúͷ豸ͬķ͵ַ
	SI24R1_Write_Reg(WRITE_REG + EN_AA, 0x01);               						// ʹܽͨ0ԶӦ
	SI24R1_Write_Reg(WRITE_REG + EN_RXADDR, 0x01);           						// ʹܽͨ0
	SI24R1_Write_Reg(WRITE_REG + RF_CH, 40);                 						// ѡƵͨ0x40
	SI24R1_Write_Reg(WRITE_REG + RX_PW_P0, TX_PLOAD_WIDTH);  						// ͨ0ѡͷͨͬЧݿ
	SI24R1_Write_Reg(WRITE_REG + RF_SETUP, 0x0f);            						// ݴ2Mbps书7dBm
	SI24R1_Write_Reg(WRITE_REG + CONFIG, 0x0f);              						// CRCʹܣ16λCRCУ飬ϵ磬ģʽ
	SI24R1_Write_Reg(WRITE_REG + STATUS, 0xff);  									//ежϱ־λ
	CE = 1;                                            								// CE豸
*/
/*
CE = 0;
	SI24R1_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);	// 豸ͨ0ʹúͷ豸ͬķ͵ַ
	SI24R1_Write_Reg(WRITE_REG + EN_RXADDR, 0x01);           						// ʹܽͨ0
	SI24R1_Write_Reg(WRITE_REG + RF_CH, 40);                 						// ѡƵͨ0x40
	SI24R1_Write_Reg(WRITE_REG + RX_PW_P0, TX_PLOAD_WIDTH);  						// ͨ0ѡͷͨͬЧݿ
	SI24R1_Write_Reg(WRITE_REG + SETUP_AW, 0x03);  									//õַ5bytes
	SI24R1_Write_Reg(WRITE_REG + 0x1d, 0x04);  										//ʹ̬ܶ
	SI24R1_Write_Reg(WRITE_REG + 0x1c, 0x01);  										//DPL P0
	SI24R1_Write_Reg(WRITE_REG + RF_SETUP, 0x0e);            						// ݴ2Mbps书7dBm
	SI24R1_Write_Reg(WRITE_REG + CONFIG, 0x0f);              						// CRCʹܣ16λCRCУ飬ϵ磬ģʽ
	CE = 1;
*/
/********************************************************
ܣSI24R1ģʽʼ                      
ڲ
  ֵ
*********************************************************/
void SI24R1_TX_Mode(void)
{
	CE = 0;
	SI24R1_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);     // д뷢͵ַ
	SI24R1_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH);  // ΪӦ豸ͨ0ַͷ͵ַͬ

	SI24R1_Write_Reg(WRITE_REG + EN_AA, 0x01);       											// ʹܽͨ0ԶӦ
	SI24R1_Write_Reg(WRITE_REG + EN_RXADDR, 0x01);   											// ʹܽͨ0
	SI24R1_Write_Reg(WRITE_REG + SETUP_RETR, 0x0a);  											// Զطʱȴ250us+86usԶط10
	SI24R1_Write_Reg(WRITE_REG + RF_CH, 40);         											// ѡƵͨ0x40
	SI24R1_Write_Reg(WRITE_REG + RF_SETUP, 0x0b);    											// ݴ2Mbps书7dBm
	SI24R1_Write_Reg(WRITE_REG + CONFIG, 0x0e);      											// CRCʹܣ16λCRCУ飬ϵ
	//CE = 1;
}


/********************************************************
ܣȡ                       
ڲrxbuf:ݴ׵ַ
  ֵ0:յ
          1:ûнյ
*********************************************************/
unsigned char SI24R1_RxPacket(unsigned char *rxbuf)
{
	unsigned char state;
	state = SI24R1_Read_Reg(STATUS);//ȡ״̬Ĵֵ    	  
	SI24R1_Write_Reg(WRITE_REG+STATUS,state);//RX_DSжϱ־

	if(state & RX_DR)//յ
	{
		SI24R1_Read_Buf(RD_RX_PLOAD,rxbuf,TX_PLOAD_WIDTH);     //ȡ
		SI24R1_Write_Reg(FLUSH_RX,0xff);//RX FIFOĴ
		return 0;
	}	   
	return 1;//ûյκ
}


/********************************************************
ܣһݰ                      
ڲtxbuf:Ҫ͵
  ֵ0x10:ﵽطʧ 
          0x20:ͳɹ            
          0xff:ʧ                  
*********************************************************/
unsigned char SI24R1_TxPacket(unsigned char *txbuf)
{
	unsigned char state;
	CE=0;//CEͣʹSI24R1
	SI24R1_Write_Reg(FLUSH_TX, 0xff);//TX FIFOĴ 
	SI24R1_Write_Reg(FLUSH_RX, 0xff);//TX FIFOĴ 
	SI24R1_Write_Buf(WR_TX_PLOAD, txbuf, TX_PLOAD_WIDTH);	    //дݵTX FIFO,32ֽ
 	CE=1;//CEøߣʹܷ	   
	mDelayuS(10);
	while(IRQ == 1);//ȴ
	state = SI24R1_Read_Reg(STATUS);//ȡ״̬Ĵֵ	   
	SI24R1_Write_Reg(WRITE_REG+STATUS, state);//TX_DSMAX_RTжϱ־
	if(state&MAX_RT)//ﵽط
	{
		SI24R1_Write_Reg(FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_RT; 
	}
	if(state&TX_DS)//
	{
		return TX_DS;
	}
	return 0xff;//ʧ
}

